# Demobeispiel_GridBag-Sizer.py
import wx

### ---------------------------------------------------
class MyFrame(wx.Frame):
    def __init__(
            self, parent, ID, title, pos=wx.DefaultPosition,
            size=wx.DefaultSize, style=wx.DEFAULT_FRAME_STYLE
            ):

        wx.Frame.__init__(self, parent, ID, title, pos, size, style)
        panel = wx.Panel(self, -1)

        gbs = self.gbs = wx.GridBagSizer(vgap=5, hgap=5)

        machtNixButton = wx.Button(panel, -1, "Macht nix")
        gbs.Add(machtNixButton, (0,0), flag=wx.ALL, border=10)
        # Position festlegen, Abstand einhalten
        besserwisserButton = wx.Button(panel, -1, "Besserwisser")
        gbs.Add(besserwisserButton, (1,0), flag=wx.ALL, border=10)
        endeButton = wx.Button(panel, -1, "Close Me")
        gbs.Add(endeButton, (2,0), flag=wx.ALL, border=10)

        label1 = wx.StaticText(panel, -1, "macht er wirklich nicht")
        gbs.Add(label1, (0,1), flag=wx.ALL, border=10)
        label2 = wx.StaticText(panel, -1, "Klugscheisser!")
        gbs.Add(label2, (1,1), flag=wx.ALL, border=10)
        label3 = wx.StaticText(panel, -1, u"und Tschüß!")
        gbs.Add(label3, (2,1), flag=wx.ALL, border=10)

        panel.SetSizerAndFit(gbs)

        self.Bind(wx.EVT_BUTTON, self.OnNix, machtNixButton)
        self.Bind(wx.EVT_BUTTON, self.OnAlles, besserwisserButton)
        self.Bind(wx.EVT_BUTTON, self.OnCloseMe, endeButton)
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

    def OnNix(self, event):
        pass

    def OnAlles(self, event):
        print("Ich weiss alles besser")

    def OnCloseMe(self, event):
        self.Close(True)

    def OnCloseWindow(self, event):
        self.Destroy()


### ---------------------------------------------------
class MyApp(wx.App):
    """Testanwendung fuer Demobeispiel"""
    def OnInit(self):
        self.fenster = MyFrame(None, 1000, "Demobeispiel")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        return True

### ---------------------------------------------------
if __name__ == '__main__':
    app = MyApp(redirect=False)
    app.MainLoop()
